--- old/usr/src/lib/fm/topo/modules/common/pcibus/pcibus_labels.c	Fri Jun 29 20:27:05 2018
+++ new/usr/src/lib/fm/topo/modules/common/pcibus/pcibus_labels.c	Fri Jun 29 20:27:05 2018
@@ -221,7 +221,7 @@
 {
 	tnode_t *anode, *apnode;
 	did_t *adp, *apdp;
-	char *plat, *pp, *l, *ancestor_l = NULL, *new_l = NULL;
+	char *plat, *pp, *l = NULL, *ancestor_l = NULL, *new_l = NULL;
 	int err, b, d, f, done = 0;
 	size_t len;
 
@@ -352,16 +352,9 @@
 		new_l = alloca(len);
 		(void) snprintf(new_l, len, "%s/%s", ancestor_l, l);
 		l = new_l;
-	} else {
+	} else if (topo_prop_get_string(node, FM_FMRI_AUTHORITY,
+	    FM_FMRI_AUTH_PRODUCT, &plat, &err) == 0) {
 		/*
-		 * Get platform name used for lookups.
-		 */
-		if (topo_prop_get_string(node, FM_FMRI_AUTHORITY,
-		    FM_FMRI_AUTH_PRODUCT, &plat, &err) < 0) {
-			(void) topo_mod_seterrno(mod, err);
-			return (NULL);
-		}
-		/*
 		 * Trim SUNW, from the platform name
 		 */
 		pp = strchr(plat, ',');
@@ -396,8 +389,13 @@
 			}
 		}
 		topo_mod_strfree(mod, plat);
+	} else {
+		(void) topo_mod_seterrno(mod, err);
+		l = NULL;
 	}
 
+	topo_mod_strfree(mod, ancestor_l);
+
 	/*
 	 * If we calculated a slot label,  then save it in the
 	 * node's data structure so we can free it later.
